package com.jiuqi.grid;

import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import com.jiuqi.util.StringUtils;
import com.jiuqi.util.inifile.StreamIni;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/* loaded from: com_jiuqi_grid.jar:com/jiuqi/grid/LabelItems.class */
public class LabelItems implements Serializable, Cloneable {
    private List list = new ArrayList();

    public LabelItem add() {
        LabelItem result = new LabelItem();
        this.list.add(result);
        return result;
    }

    public LabelItem add(int index) {
        LabelItem result = new LabelItem();
        this.list.add(index, result);
        return result;
    }

    public void remove(int index) {
        this.list.remove(index);
    }

    public void clear() {
        this.list.clear();
    }

    public int size() {
        return this.list.size();
    }

    public LabelItem get(int index) {
        return (LabelItem) this.list.get(index);
    }

    public LabelItem[] getLabelsByPos(int position) {
        LabelItem[] result = (LabelItem[]) null;
        List l = new ArrayList();
        for (int i = 0; i < size(); i++) {
            if (get(i).getPosition() == position) {
                l.add(get(i));
            }
        }
        if (l.size() > 0) {
            result = new LabelItem[l.size()];
            for (int i2 = 0; i2 < l.size(); i2++) {
                result[i2] = (LabelItem) l.get(i2);
            }
        }
        return result;
    }

    public int indexOfName(String labelName) {
        int result = -1;
        int i = 0;
        while (true) {
            if (i >= size()) {
                break;
            }
            if (!get(i).getName().equalsIgnoreCase(labelName)) {
                i++;
            } else {
                result = i;
                break;
            }
        }
        return result;
    }

    public void loadFromStream(Stream stream) throws StreamException {
        clear();
        if (stream.getSize() > 0) {
            stream.setPosition(0L);
            StreamIni ini = new StreamIni(stream);
            for (int i = 0; i < ini.readInteger("general", "count", 0); i++) {
                add().loadFromIni(i, ini);
            }
        }
    }

    public void saveToStream(Stream stream) throws StreamException {
        stream.setSize(0L);
        if (size() > 0) {
            StreamIni ini = new StreamIni(stream);
            for (int i = 0; i < size(); i++) {
                get(i).saveToIni(i, ini);
            }
            ini.writeInteger("general", "count", size());
            ini.update();
        }
    }

    public void ver10Tover11() {
        for (int i = 0; i < size(); i++) {
            LabelItem item = get(i);
            if (item.getPosition() < LabelItem.LABEL_POS_MAPS.length) {
                item.setPosition(LabelItem.LABEL_POS_MAPS[item.getPosition()]);
            }
        }
    }

    public String toString() {
        StringBuffer buffer = new StringBuffer();
        buffer.append('[');
        for (int i = 0; i < size(); i++) {
            if (i > 0) {
                buffer.append(',').append(StringUtils.LINE_SEPARATOR);
            }
            buffer.append(get(i).toString());
        }
        buffer.append(']');
        return buffer.toString();
    }
}
